using ProjectContainerShip.DrawningObjects;
using ProjectContainerShip.MovementStrategy;
using static ProjectContainerShip.Direction;

namespace ProjectWarmlyShip
{
    /// <summary>
    ///     ""
    /// </summary>
    public partial class FormContainerShip : Form
    {
        /// <summary>
        /// -   
        /// </summary>
        private DrawningShip? _drawingContainerShip;
        /// <summary>
        ///  
        /// </summary>
        private AbstractStrategy? _abstractStrategy;
        /// <summary>
        ///  
        /// </summary>
        public FormContainerShip()
        {
            InitializeComponent();
            comboBoxStrategy.Items.Add(0);
            comboBoxStrategy.Items.Add(1);
        }
        /// <summary>
        ///   
        /// </summary>
        private void Draw()
        {
            if (_drawingContainerShip == null)
            {
                return;
            }
            Bitmap bmp = new(pictureBoxWarmlyShip.Width, pictureBoxWarmlyShip.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _drawingContainerShip.DrawTransport(gr);
            pictureBoxWarmlyShip.Image = bmp;
        }
        /// <summary>
        ///    ""
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonCreate_Click(object sender, EventArgs e)
        {
            Random random = new();
            _drawingContainerShip = new DrawningShip(random.Next(100, 300), random.Next(1000, 3000),
            Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)), pictureBoxWarmlyShip.Width, pictureBoxWarmlyShip.Height);
            _drawingContainerShip.SetPosition(random.Next(10, 100), random.Next(10, 100));
            Draw();
        }
        /// <summary>
        ///    "   "
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonCreateDeckShip_Click(object sender, EventArgs e)
        {
            Random random = new();
            _drawingContainerShip = new DrawningContainerShip(random.Next(100, 300), random.Next(1000, 3000),
            Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
            Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
            Convert.ToBoolean(random.Next(0, 2)), Convert.ToBoolean(random.Next(0, 2)),
            pictureBoxWarmlyShip.Width, pictureBoxWarmlyShip.Height);
            _drawingContainerShip.SetPosition(random.Next(10, 100), random.Next(10, 100));
            Draw();
        }
        /// <summary>
        ///   
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ButtonMove_Click(object sender, EventArgs e)
        {
            if (_drawingContainerShip == null)
            {
                return;
            }
            string name = ((Button)sender)?.Name ?? string.Empty;
            switch (name)
            {
                case "buttonUp":
                    _drawingContainerShip.MoveTransport(DirectionType.Up);
                    break;
                case "buttonDown":
                    _drawingContainerShip.MoveTransport(DirectionType.Down);
                    break;
                case "buttonLeft":
                    _drawingContainerShip.MoveTransport(DirectionType.Left);
                    break;
                case "buttonRight":
                    _drawingContainerShip.MoveTransport(DirectionType.Right);
                    break;
            }
            Draw();
        }
        /// <summary>
        ///    ""
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ButtonStep_Click(object sender, EventArgs e)
        {
            if (_drawingContainerShip == null)
            {
                return;
            }
            if (comboBoxStrategy.Enabled)
            {
                _abstractStrategy = comboBoxStrategy.SelectedIndex
                switch
                {
                    0 => new MoveToCenter(),
                    1 => new MoveToBorder(),

                };
                if (_abstractStrategy == null)
                {
                    return;
                }
                _abstractStrategy.SetData(new DrawningObjectShip(_drawingContainerShip), pictureBoxWarmlyShip.Width, pictureBoxWarmlyShip.Height);
                comboBoxStrategy.Enabled = false;
            }
            if (_abstractStrategy == null)
            {
                return;
            }
            _abstractStrategy.MakeStep();
            Draw();
            if (_abstractStrategy.GetStatus() == Status.Finish)
            {
                comboBoxStrategy.Enabled = true;
                _abstractStrategy = null;
            }
        }
    }
}
